<?php
/*
Plugin Name: videoadshtml5
Version: 2.1.1
Plugin URI: https://sv-pt.ru/?p=858
Author: -sv-
Author URI: https://sv-pt.ru
Description: VideoADSHtml5
Text Domain: VideoADSHtml5
Domain Path: /languages
 */

$href = 'href.txt';
//ip что бы у разных клиентов не открывалось одно и то же видео
$ip = $_SERVER['REMOTE_ADDR'];

if (!defined('ABSPATH')) {
    exit;
}
if (!class_exists('VIDEO_HTML5_ADS')) {

    class VIDEO_HTML5_ADS {

        public static $plugin_version = '2.1.1';
		 //var $plugin_version = '2.1.1';

        function __construct() {
            define('VIDEO_HTML5_ADS_VERSION', $this->plugin_version);
            $this->plugin_includes();
        }

        function plugin_includes() {
            if (is_admin()) {
                add_filter('plugin_action_links', array($this, 'videhtml5ads_plugin_action_links'), 10, 2);
            }
            add_action('plugins_loaded', array($this, 'plugins_loaded_handler'));
            add_action('wp_enqueue_scripts', 'video_html5_ads_enqueue_scripts');
            add_action('admin_menu', array($this, 'video_html5_ads_add_options_menu'));
            add_shortcode('videoads', 'evp_embed_video_handler');
            add_filter('widget_text', 'do_shortcode');
            add_filter('the_excerpt', 'do_shortcode', 11);
            add_filter('the_content', 'do_shortcode', 11);
        }

        function plugin_url() {
            if ($this->plugin_url)
                return $this->plugin_url;
            return $this->plugin_url = plugins_url(basename(plugin_dir_path(__FILE__)), basename(__FILE__));
        }

        function video_html5_ads_plugin_action_links($links, $file) {
            if ($file == plugin_basename(dirname(__FILE__) . '/videhtml5ads.php')) {
                $links[] = '<a href="options-general.php?page=videhtml5ads-settings">'.__('Settings', 'videhtml5ads').'</a>';
            }
            return $links;
        }
        
        function plugins_loaded_handler()
        {
            load_plugin_textdomain('videhtml5ads', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/'); 
        }

        function video_html5_ads_add_options_menu() {
            if (is_admin()) {
                add_options_page(__('VideoADShtml5', 'videhtml5ads'), __('VideoADShtml5', 'videhtml5ads'), 'manage_options', 'videhtml5ads-settings', array($this, 'video_html5_ads_options_page'));
            }
            add_action('admin_init', array(&$this, 'video_html5_ads_add_settings'));
        }

        function video_html5_ads_add_settings() {
            register_setting('videhtml5ads-settings-group', 'evp_enable_jquery');
			register_setting('videhtml5ads-settings-group', 'evp_schet');
        }

        function video_html5_ads_options_page() {
            $url = "https://sv-pt.ru/?p=858";
            $link_text = sprintf(wp_kses(__('Для получения подробной документации посетите домашнюю страницу плагина <a target="_blank" href="%s">здесь</a>.', 'videhtml5ads'), array('a' => array('href' => array(), 'target' => array()))), esc_url($url));          
            ?>
			
			
            <div class="wrap">
				
                <h1>Video ADS HTML5 - v<?php echo $this->plugin_version; ?></h1>
                <div class="update-nag"><?php echo $link_text;?></div>
                    <h2 class="title"><?php _e('Основные настройки', 'videhtml5ads')?></h2>		
                        <form method="post" action="options.php">
                            <?php settings_fields('videhtml5ads-settings-group'); ?>
                            <table class="form-table">
                                <tr valign="top">
                                    <th scope="row"><?php _e('Включить jQuery', 'videhtml5ads')?></th>
                                    <td><input type="checkbox" id="evp_enable_jquery" name="evp_enable_jquery" value="1" <?php echo checked(1, get_option('evp_enable_jquery'), false) ?> /> 
                                        <p><i><?php _e('По умолчанию эта опция всегда должна быть отмечена..', 'videhtml5ads')?></i></p>
                                    </td>
                                </tr>
								<tr valign="top">
                                    <th scope="row"><?php _e('Продолжительность рекламы', 'videhtml5ads')?></th>
                                    <td><input type="text" id="evp_schet" name="evp_schet" value="<?php echo get_option('evp_schet'); ?>"> 
                                        <p><i><?php _e('Укажите продолжительность рекламы через сколько можно будет пропутить.', 'videhtml5ads')?></i></p>
										<?php // echo get_option('evp_schet'); ?>
																	
                                    </td>
                                </tr>
                            </table>
                            <p class="submit">
                                <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                            </p>
                        </form>
            </div>
			
            <?php
        }

    }
    $GLOBALS['video_html5_ads'] = new VIDEO_HTML5_ADS();
}

function video_html5_ads_enqueue_scripts() {
    if (!is_admin()) {
        $plugin_url = plugins_url('', __FILE__);
        $enable_jquery = get_option('evp_enable_jquery');
        if ($enable_jquery) {
            wp_enqueue_script('jquery');
        }
		 $schet = get_option('evp_schet');
		 //$url1 = "2342";//get_option('evp_url');
		// $GLOBALS['url1'];
		 wp_register_script('jquery',$plugin_url. 'https://code.jquery.com/jquery-3.5.1.js');
		 wp_enqueue_script('jquery');
		 wp_register_script('vast',$plugin_url. '/HTML5/js/vastvideoplugin.js');
		 wp_enqueue_script('vast');
		 wp_register_style('vast-css',$plugin_url. '/HTML5/css/site.css');
         wp_enqueue_style('vast-css');
		 wp_localize_script('vast', 'php_vars', array( 'schet' => $schet ) );
		 
		 
		 
		 $silki = file_get_contents(trailingslashit( dirname( __FILE__ ) )."HTML5/href/".$GLOBALS['ip'].$GLOBALS['href']);
		 $silki = explode(PHP_EOL, $silki);
		
		// $url3 = $url2[0];
		 //echo $url3;
		 //$url3 = $GLOBALS['href'];
		 wp_localize_script('vast', 'php_vars1', array( 'silki' => $silki[0] ) );
		 wp_localize_script('vast', 'php_vars2', array( 'silki' => $silki[1] ) );
		 wp_localize_script('vast', 'php_vars3', array( 'silki' => $silki[2] ) );
		 wp_localize_script('vast', 'php_vars4', array( 'silki' => $silki[3] ) );
		 wp_localize_script('vast', 'php_vars5', array( 'silki' => $silki[4] ) );


    }
}
function evp_embed_video_handler($atts) {
    extract(shortcode_atts(array(
        'url' => '',
		'url1' => '',
		'url2' => '',
		'url3' => '',
		'url4' => '',
        'ads' =>'',
		'ads_end' =>'',
        'width' => '',
        'height' => '',
        'ratio' => '0.417',
        'autoplay' => 'false',
        'poster' => '',
        'loop' => '',
        'muted' => '',
        'preload' => 'metadata',
        'share' => 'true',
        'video_id' => '',
        'class' => '',
        'template' => '',
		//'urldirect' => 'https://sv-pt.ru',
		'urldirect' => '',
    ), $atts));
    //check if mediaelement template is specified

    if($template=='mediaelement'){
        $attr = array();
        $attr['src'] = $url;
		$attr['src1'] = $url1;
		$attr['src2'] = $url2;
		$attr['src3'] = $url3;
		$attr['src4'] = $url4;
        $attr['ads'] = $ads;
		$attr['ads_end'] = $ads_end;
		$attr['urldirect'] = 'https://sv-pt.ru';

	

        if(is_numeric($width)){
            $attr['width'] = $width;
        }
        if(is_numeric($height)){
            $attr['height'] = $height;
        }
        if ($autoplay == "true"){
            $attr['autoplay'] = 'on';
        }
        if ($loop == "true"){
            $attr['loop'] = 'on';
        }
        if (!empty($poster)){
            $attr['poster'] = $poster;
        }
        if (!empty($preload)){
            $attr['preload'] = $preload;
        }
        return wp_video_shortcode($attr);
    }

    if(!empty($video_id)){
        $video_id = ' id="'.$video_id.'"';
    }

    if ($autoplay == "true") {
        $autoplay = " autoplay";
    } else {
        $autoplay = "";
    }

    if ($loop == "true") {
        $loop= " loop";
    }
    else{
        $loop= "";
    }

    if($muted == "true"){
        $muted = " muted";
    }
    else{
        $muted = "";
    }
    
	//Кнопки
		$hrefdir = trailingslashit(dirname( __FILE__ ))."/HTML5/href/";
		
		$plugin_version = VIDEO_HTML5_ADS::$plugin_version;
		
	
	
	$time_dir = filemtime($hrefdir);
		 $time_new = time();		 
		//	echo $time_dir;
		$time_dir60 = $time_dir + 7200; //+2 часа
		// Открываем файл для получения существующего содержимого
		//$current = file_get_contents($href);
		// Добавляем нового человека в файл
		// Пишем содержимое обратно в файл
		//file_put_contents($href, $current1);
		//Проверка на старые файлы с ip и сылками
		
	

	
	
		
		if ($time_new > $time_dir60)
		{
			foreach (glob($hrefdir."/*") as $filedir)
			unlink($filedir);
			file_put_contents($hrefdir.$GLOBALS['ip'].$GLOBALS['href'], $url."\n".$url1."\n".$url2."\n".$url3."\n".$url4);
				
		} 	else
			{
				file_put_contents($hrefdir.$GLOBALS['ip'].$GLOBALS['href'], $url."\n".$url1."\n".$url2."\n".$url3."\n".$url4);
			}
	
	
		
	if($url1 == null){
		//$url1 = $url1;//нечего неделаем
	}
		else 
		{

		//$url1="<font size=10>fdgdg</font>";}
		//$url1 = "sdfsd_".$url1;
		//echo $url1;
		$buttons="<div class='BtnVar1'>1 видео</div><div class='BtnVar2'>2 видео</div>";

		
		}
	
	if($url2 == null){
		
	}
		else 
		{
		//$url1 = "sdfsd111";
		$buttons="<div class='BtnVar1'>1 видео</div><div class='BtnVar2'>2 видео</div><div class='BtnVar3'>3 видео</div>";

		
		}
		
	if($url3 == null){
		
	}
		else 
		{
		//$url1 = "sdfsd111";
		$buttons="<div class='BtnVar1'>1 видео</div><div class='BtnVar2'>2 видео</div><div class='BtnVar3'>3 видео</div><div class='BtnVar4'>4 видео</div>";

		}	
		
	if($url4 == null){
		
	}
		else 
		{
		//$url1 = "sdfsd111";
		$buttons="<div class='BtnVar1'>1 видео</div><div class='BtnVar2'>2 видео</div><div class='BtnVar3'>3 видео</div><div class='BtnVar4'>4 видео</div><div class='BtnVar5'>5 видео</div>";

		
		}
		
	$adsvast = <<<EOT
<VAST version="2.0">
<Ad id="pre-roll-0">
<InLine>
<AdSystem>2.0</AdSystem>
<AdTitle>Sample</AdTitle>
<Impression/>
<Creatives>
<Creative sequence="1" id="2">
<Linear>
<Duration>00:02:00</Duration>
<AdParameters> </AdParameters>
<MediaFiles>
<MediaFile delivery="progressive" bitrate="400" type="video/mp4">
<URL>$ads</URL>
</MediaFile>
</MediaFiles>
</Linear>
</Creative>
</Creatives>
</InLine>
</Ad>
<Ad id="post-roll-0">
<InLine>
<AdSystem>2.0</AdSystem>
<AdTitle>Sample</AdTitle>
<Impression/>
<Creatives>
<Creative sequence="1" id="2">
<Linear>
<Duration>00:02:00</Duration>
<AdParameters> </AdParameters>
<MediaFiles>
<MediaFile delivery="progressive" bitrate="400" type="video/mp4">
<URL>$ads_end</URL>
</MediaFile>
</MediaFiles>
</Linear>
</Creative>
</Creatives>
</InLine>
</Ad>
</VAST>
EOT;
	

	
	 
	file_put_contents(trailingslashit( dirname( __FILE__ ) )."HTML5/vod/ads.xml", $adsvast);
		

    $player = "fp" . uniqid();
    $color = '';
    if (!empty($poster)) {
        $color = 'background: #000 url('.$poster.') 0 0 no-repeat;background-size: 100%;';
    } else {
        $color = 'background-color: #000;';
    }
    $size_attr = "";
    if (!empty($width)) {
        $size_attr = "max-width: {$width}px;max-height: auto;";
    }
    if(!empty($class)){
        $class = " ".$class;
    }
    $styles = <<<EOT
    <style>
        #$player {
            $size_attr
            $color
        }
    </style>
EOT;
	$adsxml = plugins_url('', __FILE__);
	//echo get_option('evp_schet');
	 $chet = get_option('evp_schet');
	//echo $chet;
	//if ($ads!="") and ($ads_end!="")
	//Блок только с первой рекламой	
	if ($ads_end == "")
	{
	
    $output = <<<EOT
<div class="urldirect">$urldirect</div>
 <center>
 <div>
	<video id="example_video" {$autoplay}{$muted} src="$url" width = "100%" height="100%" controls  
  ads = '{  "servers": [
                         {
                         "apiAddress": "$adsxml/HTML5/vod/ads.xml"
                         }
                        ],
            "schedule": [
                          {
                            "position": "pre-roll"
                          }
                        ]
        }'></video>
</div>
<span class="skipBtn"><div class="divleft">Пропустить через</div> <div id="myDiv">замена</div> из $chet</span>
	
<div class="Btnw">{$buttons}</div>

</center>

<!--Контекстное меню-->
<ul class='contextmenu'><li>v. {$plugin_version}</li></ul>
	
<script>initAdsFor("example_video");</script>

EOT;
	//Блок только с конечной рекламой
	} elseif ($ads == "")
	{
	
    $output = <<<EOT

<div class="urldirect">$urldirect</div>11
 <center>
 <div>
	<video  id="example_video" {$autoplay}{$muted} src="$url" width = "100%" height="100%" controls  
  ads = '{  "servers": [
                         {
                         "apiAddress": "$adsxml/HTML5/vod/ads.xml"
                         }
                        ],
            "schedule": [
                          {
                            "position": "post-roll"
                          }
                        ]
        }'></video>
</div>
<span class="skipBtn"><div class="divleft">Пропустить через</div> <div id="myDiv">замена</div> из $chet</span>
<div class="Btnw">{$buttons}</div>
</center>

<!--Контекстное меню-->
<ul class='contextmenu'><li>v. {$plugin_version}</li></ul>

<script>initAdsFor("example_video");</script>

EOT;

	}  
		//Блок без рекламы
		elseif (($ads == "") and ($ads_end == ""))
	{
	
    $output = <<<EOT
<div class="urldirect">$urldirect</div>111
 <center>
 <div>
	<video id="example_video" {$autoplay}{$muted} src="$url" width = "100%" height="100%" ></video>
</div>
<span class="skipBtn"><div class="divleft">Пропустить через</div> <div id="myDiv">замена</div> из $chet</span>
<div class="Btnw">{$buttons}</div>
</center>

<!--Контекстное меню-->
<ul class='contextmenu'><li>v. {$plugin_version}</li></ul>

<script>initAdsFor("example_video");</script>



EOT;
		
	} 
		//Блок только с двумя блоками рекламы
		else
		
		{
					
			 $output = <<<EOT

<div class="urldirect">$urldirect</div>1111
 <center>
 <div>
	<video onClick="startTimer()" id="example_video" {$autoplay}{$muted} src="$url" width = "100%" height="100%" controls  
  ads = '{  "servers": [
                         {
                         "apiAddress": "$adsxml/HTML5/vod/ads.xml"
                         }
                        ],
            "schedule": [
                          {
                            "position": "pre-roll"
                          },
						  {
                            "position": "post-roll"
                          }
						  
                        ]
        }'></video>
</div>

<span class="skipBtn"><div class="divleft">Пропустить через</div> <div id="myDiv">замена</div> из $chet</span>
<div class="Btnw">{$buttons}Пропустить через</div>
</center>

<!--Контекстное меню-->
<ul class='contextmenu'><li>v. {$plugin_version}</li></ul>

<script>initAdsFor("example_video");</script>



EOT;
			
			
		}

    return $output;
}
